%define glib2_version 2.4.0
%define pango_version 1.4.0
%define gtk2_version 2.10.0
%define libgnome_version 2.13.7
%define libgnomeui_version 2.13.2
%define gail_version 1.2
%define desktop_file_utils_version 0.2.90
%define gstreamer_version 0.10.3

%define gettext_package gnome-media-2.0

Summary:        GNOME media programs
Name:           gnome-media
Version:        2.29.91
Release:        6%{?dist}
License:        GPLv2+ and GFDL
Group:          Applications/Multimedia
Source:         http://download.gnome.org/sources/gnome-media/2.29/gnome-media-%{version}.tar.bz2

URL:            http://www.gnome.org
ExcludeArch:    s390 s390x

Requires(post): GConf2 >= 2.14
Requires(pre): GConf2 >= 2.14
Requires(preun): GConf2 >= 2.14

BuildRequires:  gtk2-devel >= %{gtk2_version}
BuildRequires:  glade3-libgladeui-devel
BuildRequires:  GConf2-devel
BuildRequires:  desktop-file-utils >= %{desktop_file_utils_version}
BuildRequires:  gstreamer-devel >= %{gstreamer_version}
BuildRequires:  gstreamer-plugins-base-devel >= %{gstreamer_version}
BuildRequires:  gstreamer-plugins-good-devel
BuildRequires:  dbus-glib-devel
BuildRequires:  libcanberra-devel
BuildRequires:  pulseaudio-libs-devel
BuildRequires:  gnome-doc-utils
BuildRequires:  intltool
BuildRequires:  unique-devel
BuildRequires:  scrollkeeper

# https://bugzilla.gnome.org/show_bug.cgi?id=519438
Patch0: 0001-Add-speaker-testing-UI.patch
BuildRequires: automake autoconf libtool gnome-common intltool

# https://bugzilla.redhat.com/show_bug.cgi?id=595519
Patch1: gnome-media-2.29.91-fix-omf-category.patch

# translation updates
# https://bugzilla.redhat.com/show_bug.cgi?id=589205
Patch2: gnome-media-translations.patch

# https://bugzilla.gnome.org/show_bug.cgi?id=620360
Patch3: 0001-Force-updating-the-custom-theme-dir-on-change.patch

# https://bugzilla.gnome.org/show_bug.cgi?id=620365
Patch4: 0001-Fix-alert-preview-requiring-a-double-click.patch

%description
This package contains a few media utilities for the GNOME desktop,
including a volume control and a configuration utility for audio profiles.

%package devel
Summary: Development files for gnome-media
Group: Development/Libraries
Requires: %{name}-libs = %{version}-%{release}
Requires: gtk2-devel >= %{gtk2_version}
Requires:  glade3-libgladeui-devel

%description devel
This package contains the libraries and header files necessary to
develop GNOME media applications.

%package libs
Summary: Libraries for gnome-media
Group: Development/Libraries
Requires: %{name} = %{version}-%{release}

%description libs
This package contains the libraries required for using encoding profiles
in GNOME media applications.

%package apps
Summary: Some media-related applications for the GNOME desktop
Group: Applications/Multimedia
Requires: %{name} = %{version}-%{release}

%description apps
This package contains an application to record and play sound files
in various formats and a configuration utility for the gstreamer media
framework.

%prep
%setup -q
%patch0 -p1 -b .speaker-test
%patch1 -p1 -b .fix-omf-category
%patch2 -p1 -b .translations
%patch3 -p1 -b .old-alert
%patch4 -p1 -b .preview

autoreconf -f

# force regeneration
rm profiles/gnome-audio-profiles.schemas

%build
%configure --disable-schemas-install --enable-gnomecd=no --enable-cddbslave=no
make #%{?_smp_mflags}

%install
rm -rf $RPM_BUILD_ROOT

make install DESTDIR=$RPM_BUILD_ROOT

# show in all
desktop-file-install --vendor gnome --delete-original       \
  --dir $RPM_BUILD_ROOT%{_datadir}/applications             \
  $RPM_BUILD_ROOT%{_datadir}/applications/gnome-sound-recorder.desktop

desktop-file-install --vendor "" --delete-original          \
  --dir $RPM_BUILD_ROOT%{_datadir}/applications             \
  $RPM_BUILD_ROOT%{_datadir}/applications/gstreamer-properties.desktop

rm -f $RPM_BUILD_ROOT%{_datadir}/applications/vumeter.desktop
rm -f $RPM_BUILD_ROOT%{_datadir}/applications/reclevel.desktop
rm -f $RPM_BUILD_ROOT%{_bindir}/vumeter

rm -rf $RPM_BUILD_ROOT%{_libdir}/lib*.*a
rm -rf $RPM_BUILD_ROOT%{_libdir}/glade3/modules/lib*.*a
rm -rf $RPM_BUILD_ROOT/var/scrollkeeper

# save space by linking identical images in translated docs
for helpdir in $RPM_BUILD_ROOT%{_datadir}/gnome/help/*; do
  for f in $helpdir/C/figures/*.png; do
    b="$(basename $f)"
    for d in $helpdir/*; do
      if [ -d "$d" -a "$d" != "$helpdir/C" ]; then
        g="$d/figures/$b"
        if [ -f "$g" ]; then
          if cmp -s $f $g; then
            rm "$g"; ln -s "../../C/figures/$b" "$g"
          fi
        fi
      fi
    done
  done
done

%find_lang %{gettext_package}
%find_lang gnome-audio-profiles --with-gnome
%find_lang gnome-sound-recorder --with-gnome
%find_lang gstreamer-properties --with-gnome
cat gnome-audio-profiles.lang >> apps.lang
cat gnome-sound-recorder.lang >> apps.lang
cat gstreamer-properties.lang >> apps.lang

%clean
rm -rf $RPM_BUILD_ROOT

%post
touch --no-create %{_datadir}/icons/hicolor >&/dev/null || :

%post apps
export GCONF_CONFIG_SOURCE=`gconftool-2 --get-default-source`
gconftool-2 --makefile-install-rule \
    %{_sysconfdir}/gconf/schemas/gnome-sound-recorder.schemas \
    > /dev/null || :
touch --no-create %{_datadir}/icons/hicolor >&/dev/null || :

%post libs
export GCONF_CONFIG_SOURCE=`gconftool-2 --get-default-source`
gconftool-2 --makefile-install-rule \
    %{_sysconfdir}/gconf/schemas/gnome-audio-profiles.schemas \
    > /dev/null || :
/sbin/ldconfig

%pre
if [ "$1" -gt 1 ]; then
  export GCONF_CONFIG_SOURCE=`gconftool-2 --get-default-source`
  if [ -f %{_sysconfdir}/gconf/schemas/gnome-cd.schemas ] ; then
    gconftool-2 --makefile-uninstall-rule \
      %{_sysconfdir}/gconf/schemas/gnome-cd.schemas \
      %{_sysconfdir}/gconf/schemas/CDDB-Slave2.schemas \
      > /dev/null || :
  fi
  if [ -f %{_sysconfdir}/gconf/schemas/gnome-sound-recorder.schemas ] ; then
    gconftool-2 --makefile-uninstall-rule \
      %{_sysconfdir}/gconf/schemas/gnome-sound-recorder.schemas \
      > /dev/null || :
  fi
  if [ -f %{_sysconfdir}/gconf/schemas/gnome-volume-control.schemas ] ; then
    gconftool-2 --makefile-uninstall-rule \
      %{_sysconfdir}/gconf/schemas/gnome-volume-control.schemas \
      > /dev/null || :
  fi
fi

%pre libs
if [ "$1" -gt 1 ]; then
  export GCONF_CONFIG_SOURCE=`gconftool-2 --get-default-source`
  gconftool-2 --makefile-uninstall-rule \
  %{_sysconfdir}/gconf/schemas/gnome-audio-profiles.schemas \
  > /dev/null || :
fi

%pre apps
if [ "$1" -gt 1 ]; then
  export GCONF_CONFIG_SOURCE=`gconftool-2 --get-default-source`
  if [ -f %{_sysconfdir}/gconf/schemas/gnome-sound-recorder.schemas ] ; then
    gconftool-2 --makefile-uninstall-rule \
      %{_sysconfdir}/gconf/schemas/gnome-sound-recorder.schemas \
      > /dev/null || :
  fi
fi

%preun
if [ "$1" -eq 0 ]; then
  export GCONF_CONFIG_SOURCE=`gconftool-2 --get-default-source`
  if [ -f %{_sysconfdir}/gconf/schemas/gnome-cd.schemas ] ; then
    gconftool-2 --makefile-uninstall-rule \
      %{_sysconfdir}/gconf/schemas/gnome-cd.schemas \
      %{_sysconfdir}/gconf/schemas/CDDB-Slave2.schemas \
      > /dev/null || :
  fi
  if [ -f %{_sysconfdir}/gconf/schemas/gnome-sound-recorder.schemas ] ; then
    gconftool-2 --makefile-uninstall-rule \
      %{_sysconfdir}/gconf/schemas/gnome-sound-recorder.schemas \
      > /dev/null || :
  fi
  if [ -f %{_sysconfdir}/gconf/schemas/gnome-volume-control.schemas ] ; then
    gconftool-2 --makefile-uninstall-rule \
      %{_sysconfdir}/gconf/schemas/gnome-volume-control.schemas \
      > /dev/null || :
  fi
fi

%preun apps
if [ "$1" -gt 1 ]; then
  export GCONF_CONFIG_SOURCE=`gconftool-2 --get-default-source`
  if [ -f %{_sysconfdir}/gconf/schemas/gnome-sound-recorder.schemas ] ; then
    gconftool-2 --makefile-uninstall-rule \
      %{_sysconfdir}/gconf/schemas/gnome-sound-recorder.schemas \
      > /dev/null || :
  fi
fi

%preun libs
if [ "$1" -eq 0 ]; then
  if [ -f %{_sysconfdir}/gconf/schemas/gnome-audio-profiles.schemas ] ; then
    export GCONF_CONFIG_SOURCE=`gconftool-2 --get-default-source`
    gconftool-2 --makefile-uninstall-rule \
    %{_sysconfdir}/gconf/schemas/gnome-audio-profiles.schemas \
    > /dev/null || :
  fi
fi

%postun
if [ $1 -eq 0 ]; then
  touch --no-create %{_datadir}/icons/hicolor >&/dev/null || :
  gtk-update-icon-cache --quiet %{_datadir}/icons/hicolor >&/dev/null || :
fi

%postun libs -p /sbin/ldconfig

%postun apps
if [ $1 -eq 0 ]; then
  touch --no-create %{_datadir}/icons/hicolor >&/dev/null || :
  gtk-update-icon-cache --quiet %{_datadir}/icons/hicolor >&/dev/null || :
fi

%posttrans
gtk-update-icon-cache --quiet %{_datadir}/icons/hicolor >&/dev/null || :

%posttrans apps
gtk-update-icon-cache --quiet %{_datadir}/icons/hicolor >&/dev/null || :

%files
%defattr(-, root, root)
%doc AUTHORS COPYING NEWS README
%{_bindir}/gnome-volume-control
%{_bindir}/gnome-volume-control-applet
%{_bindir}/gnome-audio-profiles-properties
%{_sysconfdir}/xdg/autostart/gnome-volume-control-applet.desktop
%{_datadir}/applications/gnome-volume-control.desktop
%{_datadir}/icons/hicolor/*/apps/gnome-volume-control*
%{_datadir}/gnome-media
%{_datadir}/sounds/gnome/

%files libs -f %{gettext_package}.lang
%defattr(-, root, root)
%config %{_sysconfdir}/gconf/schemas/gnome-audio-profiles.schemas
%{_libdir}/*.so.*

%files devel
%defattr(-, root, root)
%{_includedir}/*
%{_libdir}/*.so
%{_libdir}/pkgconfig/*
%{_libdir}/glade3/modules/libgnome-media-profiles.so
%{_datadir}/glade3/catalogs/gnome-media-profiles.xml

%files apps -f apps.lang
%defattr(-, root, root)
%{_bindir}/gnome-sound-recorder
%{_datadir}/gnome-sound-recorder
%config %{_sysconfdir}/gconf/schemas/gnome-sound-recorder.schemas
%{_datadir}/applications/gnome-sound-recorder.desktop
%{_datadir}/icons/hicolor/*/apps/gnome-sound-recorder*

%{_bindir}/gstreamer-properties
%{_datadir}/gstreamer-properties
%{_datadir}/applications/gstreamer-properties.desktop
%{_datadir}/icons/hicolor/*/apps/gstreamer-properties*



%changelog

